#ifndef TIMEVARPARS_H
#define TIMEVARPARS_H

#include <cstring>
#include <vector>


class CTimeVaryingParams {
    public:
    bool simulparsWrittenBool;
    int 	dens;//nbre d'individus diploides par noeud (non vide!)
	int 	initialDens;//nbre d'individus diploides par noeud (non vide!) ayu debut de la phase demo
    int 	dimRes1; // doit etre <=  dim_reseau1
    int 	dimRes2; //1...doit etre <=  dim_reseau2
    bool 	fixe;//=0 si il existe des noeud vides sur le reseau
    int 	vide;//1 si pas de noeuds vides 2,3 si il existe des noeuds vide ( 1sur 2, 1 sur 3)
    bool 	zone;//1 si il existe une zone de densite differente du reste
	int		xmin_zone,xmax_zone,ymin_zone,ymax_zone;// coord de la zone
    int 	vide_zone;//si il y a des noeuds vides dans la zone
    int 	dens_zone;//nbre d'individus par noeud dans la zone
	bool	barrier,barrierX,barrierY;
	int		x1_barrier,x2_barrier,y1_barrier,y2_barrier;
	double	barrierCrossingRate;
    char 	mod; /*S ou g... Modele de dispersion *chercher cette option pour en modif les params*/
    double	Mig,GeoG,Pareto_Shape;
	int 	dist_max;//distance maximale de dispersion
    double Sichel_Gamma,Sichel_Xi,Sichel_Omega;
    std::string ContSizeChange;
    double LogisticGrowthRate;
    unsigned long int minGen; //starting time of the demographic phase, starting from recent=0
    CTimeVaryingParams()  {
        simulparsWrittenBool=false;
        dens=1;
		initialDens=1;
        dimRes1=10;
        dimRes2=1;
        fixe=true;
        vide=1;
        zone=false;
        vide_zone=1;
        dens_zone=1;
        xmin_zone=1;
        xmax_zone=1;
        ymin_zone=1;
        ymax_zone=1;
		barrier=false;
		barrierX=false;
		barrierY=false;
        x1_barrier=1;
        x2_barrier=1;
        y1_barrier=1;
        y2_barrier=1;
        barrierCrossingRate=0;
        dist_max=-1;
        mod='b';
        Mig=0.5;
        GeoG=0.5;
        Pareto_Shape=5;
        Sichel_Gamma=-2.15;
        Sichel_Xi=100;
        Sichel_Omega=-1;
        ContSizeChange="None";
        LogisticGrowthRate=0.0;
        minGen=1;
    };
    CTimeVaryingParams(CTimeVaryingParams* modele)  {
		initialDens=modele->initialDens;
		dens=modele->dens;
        dimRes1=modele->dimRes1;
        dimRes2=modele->dimRes2;
        fixe=modele->fixe;
        vide=modele->vide;
        zone=modele->zone;
        dens_zone=modele->dens_zone;
        vide_zone=modele->vide_zone;
		xmin_zone=modele->xmin_zone;
        xmax_zone=modele->xmax_zone;
        ymin_zone=modele->ymin_zone;
        ymax_zone=modele->ymax_zone;
        barrier=modele->barrier;
        barrierX=modele->barrierX;
        barrierY=modele->barrierY;
        x1_barrier=modele->x1_barrier;
        x2_barrier=modele->x2_barrier;
        y1_barrier=modele->y1_barrier;
        y2_barrier=modele->y2_barrier;
        barrierCrossingRate=modele->barrierCrossingRate;
        dist_max=modele->dist_max;
        mod=modele->mod;
        Mig=modele->Mig;
        GeoG=modele->GeoG;
        Pareto_Shape=modele->Pareto_Shape;
        Sichel_Gamma=modele->Sichel_Gamma;
        Sichel_Xi=modele->Sichel_Xi;
        Sichel_Omega=modele->Sichel_Omega;
        ContSizeChange="None";//il ne faut pas passer cet argument sinon on refait un changement de taille de pop continu, a revoir RL->RL
        LogisticGrowthRate=0.0;
        minGen=1;
    };
    ~CTimeVaryingParams() {};
    int setGrowthPars(CTimeVaryingParams* nextTVpars);
    int computeCumuls();
    int currentDens(long unsigned int& locCurrentGeneration);
    void forw();
    void oneDProductWithoutm0();
    void realise_disp();
    int calcul_densite(int coordx,int coordy);
	int PrintTVpars();

    private:

    long int Dt;//difference de temps entre phases demo
    int Dsize;//differences de taille de pops entre phases demo
	float Rsize;//ratio de taille de pops entre phases demo
    float growthRate;
    int KLogistic;
};

extern std::vector<CTimeVaryingParams> TVpars;


#endif
